#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
using System.Windows.Forms;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "ControlCursor",AutoEvaluate=true, Category = "Value", Help = "Basic template with one value in/out", Tags = "c#")]
	#endregion PluginInfo
	public class ValueControlCursorNode : IPluginEvaluate
	{
		public enum CursorType
		{
			Default,
			SizeNS,		
			Help,
			Wait
			
		}
		#region fields & pins
		[Input("Input", DefaultValue = 1.0)]
		public IDiffSpread<CursorType> FInput;

		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			if (FInput.IsChanged)
			{
				switch (this.FInput[0])
				{
					case CursorType.Default:
						Cursor.Current = Cursors.Default;
						break;
					case CursorType.Help:
						Cursor.Current = Cursors.Help;
						break;
					case CursorType.SizeNS:
						Cursor.Current = Cursors.SizeNS;
						break;	
					case CursorType.Wait:
						Cursor.Current = Cursors.WaitCursor;
						break;	
					default:
						Cursor.Current = Cursors.Default;
						break;	
				}
			}		
		}
	}
}
